mod body;
mod header;
mod request;
mod response;

use serde::{Deserialize, Serialize};

use self::{body::Body, header::Header};

#[repr(u8)]
#[derive(Debug, Clone, Serialize, Deserialize, FromPrimitive)]
pub enum MessageType {
    None = 0x00,
    Set = 0x02,
    Query = 0x03,
    Notify1 = 0x04,
    Notify2 = 0x05,
    Exception = 0x06,
    QuerySN = 0x07,
    Exception2 = 0x0A,
    QuerySubtype = 0xA0,
}

impl Default for MessageType {
    fn default() -> Self {
        Self::None
    }
}

#[derive(Debug, Clone)]
pub struct Command {
    pub(crate) header: Header,
    pub(crate) body: Body,
}

impl Command {}
