use crate::command::Command;

pub mod e1;

pub trait DeviceBackend {
    fn build_query(&self, device_protocol_version: u32) -> anyhow::Result<Vec<Command>>;
    fn process_message(&self, msg: &[u8]) -> anyhow::Result<Vec<u8>>;
    fn set_attribute(&self, attribute: &str, value: &str) -> ();
}
