use std::num::ParseIntError;

#[macro_use]
extern crate num_derive;

mod cloud;
mod cloud_security;
mod command;
mod device;
mod devices;
mod discover;
mod packet_builder;
mod security;

fn hex(s: &str) -> Result<Vec<u8>, ParseIntError> {
    (0..s.len())
        .step_by(2)
        .map(|i| u8::from_str_radix(&s[i..i + 2], 16))
        .collect()
}

pub use cloud::Cloud;
pub use device::Device;
pub use discover::{DeviceInfo, Startup};
